function data = load_data(file_name)
 
    % Check if folder path is stored
    filename = '.path_data.txt';
    if isfile(filename)
        fid = fopen(filename,'r');
        path = fscanf(fid,'%s');
        fclose(fid);
    else
        path = '';
    end
    
    
    if exist(path,'dir') == 0 || ~isfile(filename)
        % Ask user to select folder with data
        path = uigetdir('','Select folder where the .mat data is located!!');
        if path == 0
            error('No folder selected. Please select a folder!');
        end
        % Save folder in file
        fid = fopen(filename,'wt');
        fprintf(fid, '%s', path);
        fclose(fid);
    end
    
    
    % Separator system specific
    if ispc
        separator = '\';
    else
        separator = '/';
    end
    
    % Check if filename is given
    if exist('file_name','var') == 0
        [file_name,~]   = uigetfile('*.mat','Select data set',path);
    end
    
    % Load data
    data = load([path separator file_name]);
end