function [sig_new,i_noise]=remove_noise(sig,cutoff_acc,check_result)
%[sig_new,i_noise]=remove_noise(sig,cutoff_acc,check_result)
%this function removes visible noise (large jumps) from optotrac data
%%Input
% sig         : signal that the noise should be removed from
% cutoff_acc  : maximal acceptable acceleration (depends on sample frequency and scale (e.g. m or mm))
% check_result: if==1 figure is plotted
%%Output
% sig_new : newe signal
% i_noise : indexes of removed noise

sig(sig==0)=nan;
d_sig=[ones(1,size(sig,2))*nan; abs(diff(sig))];
dd_sig=[ones(1,size(sig,2))*nan; abs(diff(diff(sig))); ones(1,size(sig,2))*nan];
noise=find(dd_sig>cutoff_acc);

%% remove 3 samples around noise
i_noise=[noise-3 noise-2 noise-1 noise  noise+1 noise+2 noise+3];
%i_noise=[noise-5 noise-4 noise-3 noise-2 noise-1 noise  noise+1 noise+2 noise+3 noise+4 noise+5];
%i_noise=[noise-6 noise-5 noise-4 noise-3 noise-2 noise-1 noise  noise+1 noise+2 noise+3 noise+4 noise+5 noise-6];
%i_noise=[noise-7 noise-6 noise-5 noise-4 noise-3 noise-2 noise-1 noise  noise+1 noise+2 noise+3 noise+4 noise+5 noise-6 noise-7];

sig_new=sig;
sig_new(i_noise)=nan;%remove noise!!

if check_result==1
    subplot(231),plot(sig);title('raw sig')
    subplot(232),plot(d_sig);axis([0 length(sig) 0 cutoff_acc*5]);title('raw diff(sig)')
    subplot(233),plot(dd_sig);axis([0 length(sig) 0 cutoff_acc*2]);title('raw diff(diff(sig))')
    hline(cutoff_acc,':k');
    d_sig_new=[ones(1,size(sig,2))*nan; abs(diff(sig_new))];
    dd_sig_new=[ones(1,size(sig,2))*nan; abs(diff(diff(sig_new))); ones(1,size(sig,2))*nan];
    subplot(234),plot(sig_new);title('sig after correction (AC)')
    subplot(235),plot(d_sig_new);axis([0 length(sig) 0 cutoff_acc*5]);title('diff(diff(sig)) AC')
    subplot(236),plot(dd_sig_new);axis([0 length(sig) 0 cutoff_acc*2]);title('diff(diff(sig)) AC')
    hline(cutoff_acc,':k');
end