function [eX eY eZ] = triad(origin, y, z)

%check dimension consistency and transpose if needed
if size(origin,1) ~= size(y,1) || size(origin,1) ~= size(z,1)
    warning('warning: dimensions of inputs is inconsistent')
    return
end

if size(origin,2) == 3
    flip = 1;
    origin = origin';
    y = y';
    z = z';
else 
    flip = 0;
end

%create unit vectors
for idx = 1:length(origin)
    %calculating directional vectors of triads
    eZ(1:3,idx) = z(1:3,idx)-origin(1:3,idx);
    eY(1:3,idx) = y(1:3,idx)-origin(1:3,idx);
    eX(1:3,idx) = cross(eY(1:3,idx),eZ(1:3,idx));  
    
    %normalizing to unitvector
    eZ(1:3,idx) = eZ(1:3,idx)./norm(eZ(1:3,idx));
    eY(1:3,idx) = eY(1:3,idx)./norm(eY(1:3,idx));
    eX(1:3,idx) = eX(1:3,idx)./norm(eX(1:3,idx));
end 

%transpose unitvectors back to original dimensions
if flip == 1
    eX = eX';
    eY = eY';
    eZ = eZ';
end